#! /usr/bin/perl
use LWP::UserAgent;
use HTML::LinkExtor;
use URI::URL;

use HTTP::Request;
use HTTP::Response;
use URI::Heuristic;
use MIME::Lite;

$url = "http://www.wikipedia.com/wiki.cgi?Wikipedia/Article_a_day_queue";  # for instance
$ua = new LWP::UserAgent;

# Set up a callback that collect image links
my @imgs = ();
sub callback {
    my($tag, %attr) = @_;
    return if $tag ne 'a';  # we only look closer at <img ...>
    push(@imgs, values %attr);
}

# Make the parser.  Unfortunately, we don't know the base yet
# (it might be diffent from $url)
$p = HTML::LinkExtor->new(\&callback);

# Request document and parse it as it arrives
$res = $ua->request(HTTP::Request->new(GET => $url), sub {$p->parse($_[0])});       




# Expand all image URLs to absolute ones
my $base = $res->base;
@imgs = map { $_ = url($_, $base)->abs; } @imgs;

# Print them out
#my $mark1 = 0;
#my $mark2 = 0;
#my $i = 0;
#my $j = 1;
#foreach my $elem (@imgs) {
#    if ($elem =~ /Article_a_day_queue/ ) {
#	$mark{$j} = $i;
#	$j++;
#	$mark1 = $i;
#    }
#    elsif ($elem =~ /wiki.cgi\?HomePage/){
#	$mark2 = $i;
#    }
#    $i++;
#}


#print "$mark1 and $mark2 and $mark{1}\n";
#for ($j = $mark{1} + 1; $j < ($mark2 -1); $j++) {
my $logfile = "/home/wiki/lib-http/bin/article_a_day.log";

open (INFILE, $logfile) or die "Can't open log file: article_a_day.log\n";
while (<INFILE>) {
    @data = split(/\|/, $_);
}
close (INFILE);

my @localtime=localtime(time);
my $dated = sprintf("%0.4d%0.2d%0.2d",$localtime[5]+1900,$localtime[4]+1,$localtime[3]);  

if ($data[1] eq '') {$data[1] = 0 };
$realindex = $data[1] + 1;
$index = 6 + $realindex;

open (OUTFILE, ">>$logfile") or die "Can't open log file: article_a_day.log\n";
print OUTFILE "$dated|$realindex|$imgs[$index]\n";
close (OUTFILE);

for ($j = $index; $j < $index+1; $j++) {
    @titles = split(/\//, $imgs[$j]);

    $body = `/usr/bin/lynx -dump $imgs[$j]`;
    @newbody = split(/_________________________________________________________________/, $body);

    $i = 0;
    foreach my $tempdata (@newbody) {    
#	if ($i != 0 && $i != (scalar(@newbody)-1) && $tempdata !~ /\/Talk/g) {
	if ($i != 0 && $i != (scalar(@newbody)-1)) {
	    $goodstuff = $goodstuff.$tempdata;
	}
	$i++;
    }
    
    $titles[scalar(@titles) - 1] =~ s/\_/ /g; 
    $subject =  "Wikipedia: ".$titles[scalar(@titles) - 1]."\n";
    $body = "$imgs[$j]\n\n";
    $body.= "Today's article:\n";
    $body .= $titles[scalar(@titles)-1]."\n";
    $goodstuff =~ s/\n\s{3}/\n/g;
    $goodstuff =~ s/\[\d*\]//g;
    $goodstuff =~ s/\]\?|\[//g;
    $goodstuff =~ s/\/Talk//g;

    $body .= $goodstuff;

}


############################################
# Get the subscribe email then send        #
############################################
use DBI;
$mydb = DBI->connect('dbi:mysql:nupedia', 'goodguy', 'sqlpedia');
#$checku = $mydb->prepare("select email from wiki_subscribe where  email='toan\@bomis.com' or email='dtoan123\@hotmail.com'");
$checku = $mydb->prepare("select email from wiki_subscribe where  active=1");
$checku->execute;
while (my ($email) = $checku->fetchrow_array) {
    $yourmail = $email;
    $cryptmail = crypt($yourmail, 'jw');
    print "The email is $email\n";

    $temp = "
----------

You have received the above article because you subscribed to the
Wikipedia article-a-day service.  To unsubscribe, simply click on the
following link:

http://www.wikipedia.com/unsubscribe.cgi?address=$yourmail&y=$cryptmail
";
    $bodynew = $body.$temp;
    &mailme($email);
#    print "$bodynew \n\n";
}

#print "$subject";
#print "$body";



sub mailme() {
    if ($bodynew ne '') {
        $mail = new MIME::Lite
        From 	=>"system\@nupedia.com",
        To 		=>"$_[0]",
        Subject 	=>"$subject",
        Type	=>'text/plain',
        Encoding	=>'7bit',
        Data 	=>$bodynew;
	$mail->send;
    }	
}
