#!/usr/bin/perl
use DBI;
# August 29, 2001 -- Jimmy Wales

$COLOR = "#FFFFCC";
$MB = 0;
$DBDIR = '/home/wiki/lib-http/db';

use FCGI;
use CGI::Fast qw(:cgi-lib);
use DB_File;

# This is the initialization phase (where we load the data)
$usecount = 0;  # How many searches have been conducted

$format_1 = qq^<table border=0 width=610 cellspacing=5 cellpadding=1><tr><td align=right
width=20><font face="Helvetica, Arial" size=-1>^;
# Then the count
$format_2 = qq^</font></td><td width=590><font face="Helvetica,Arial"><b>^;
# Then the headline (clickable)
$format_3 = qq^</b></font></td></tr><tr valign=top><td
align=right>&nbsp;</td><td><font face="Helvetica, Arial" size=-1>^;
# Then the longdesc
$format_4 = qq^</font></td></tr></table>^;

$FS  = "\xb3";      # The FS character is a superscript "3"
$FS1 = $FS . "1";   # The FS values are used to separate fields
$FS2 = $FS . "2";   # in stored hashtables and other data structures.
$FS3 = $FS . "3";   # The FS character is not allowed in user data.


srand($$);

tie(%lookup, 'DB_File', "$DBDIR/fulltext.db", O_RDONLY, 0400, $DB_BTREE)
  || &log_dbmopen_failure("$DBDIR/fulltext.db");

tie(%desc, 'DB_File', "$DBDIR/desc.db", O_RDONLY, 0400, $DB_BTREE)
  || &log_dbmopen_failure("$DBDIR/desc.db");

while(new CGI::Fast) {
  $usecount++;
  undef(%rqpairs);  # Keeps things clear
  undef (@encresults);
  undef (%totalscore);
  &ReadParse(*rqpairs);
  
  open(LOGFILE, ">>search.log");
  print LOGFILE "$rqpairs{'request'}|$ENV{'HTTP_REFERER'}|$ENV{'REMOTE_ADDR'}\n";
  close(LOGFILE);

  $rqpairs{'request'} =~ s/"//g;
  $rqpairs{'request'} =~ s/\+/ /g;
  $rqpairs{'request'} =~ s/\_//g;
  $rqpairs{'request'} =~ s/\\//g;
  $rqpairs{'request'} =~ s/\|//g;
  $rqpairs{'request'} =~ s/\(//g;
  $rqpairs{'request'} =~ s/\)//g;
  $rqpairs{'request'} =~ s/\[//g;
  $rqpairs{'request'} =~ s/\]//g;
  $x = $rqpairs{'request'};
  $x =~ s/ /+/g;

  &print_page_top();


print "</center>";

  FCGI::flush();



@searchterms = split(/\s+/, $rqpairs{'request'});
$num_terms = @searchterms;

  if ($num_terms == 0) {
	  &handle_blank_request();
	  next;
	}

$base_factor = 500 / $num_terms;
foreach $term (@searchterms) {
    $term = lc($term);
    $term =~ s/s$//;
    $term =~ s/ing$//g;
    @results = split(/\|/, $lookup{$term});
#    print "<br>Raw results for $term: $lookup{$term}\n";

    $uselessness = @results;
    next if ($uselessness > 1400);
    foreach $result (@results) {
        ($page, $count) = split($FS, $result);
        unless (defined($totalscore{$page})) {
            $totalscore{$page}++;
        }
        if ($page =~ /\//) { $count = $count / 2; }; # penalize sub pages
        $totalscore{$page} = $totalscore{$page} * (($count/$uselessness)*$base_factor);
    }
}

undef (@encresults);

# The following loop is too slow.  We're looking up the entire
# longdesc for every result, even though we only show some results.
# We don't need the longdesc for sorting, so that part should happen
# later

while (($result, $score) = each(%totalscore)) {
#      $score = $score * $totalhits{$result} * $totalhits{$result};
      $score = sprintf("%12d", $score);

       $pline  = $format_1;
       $pline .=  $score;
       $pline .= $format_2;
       $pline .= "<a href=";
       $pline .= "\"/wiki/$result\">";
       $temp = $result;
       $temp =~ s/_/ /g;
       $pline .= "$temp</a>";
       $pline .= $format_3;
       $pline .= "|$result";
       		push(@encresults, $pline);
       }
  @s_encresults = reverse sort @encresults;
  $enc_matchcount = @s_encresults;

#  print "<center>\n";
  unless (defined($rqpairs{'s'})) { $rqpairs{'s'} = 1 };
  unless (defined($rqpairs{'n'})) { $rqpairs{'n'} = 10 };
  $i=0;

  $matchcount = $enc_matchcount;
  print "$enc_matchcount articles found.<br>\n";
  if ($enc_matchcount > 0) {
	print "<table width=610 height=3 bgcolor=$COLOR>";
	print "<tr><td><b>Wikipedia Articles</b></td></tr></table>\n";
  $i = 0;
  $start = $rqpairs{'s'};
  $end = $rqpairs{'s'}+$rqpairs{'n'}-1;
  $p_end = $end;
  if ($end > $enc_matchcount) {$p_end = $enc_matchcount;}
  print "Results $start through $p_end of $enc_matchcount for $rqpairs{'request'}.\n" unless ($matchcount==0);
  foreach $line (@s_encresults) {
    $i++;
    next if ($i < $start);
    last if ($i > $end);
       ($pline, $result) = split(/\|/, $line);
       ($headline, $longdesc) = split(/\|/,$desc{$result});
       $longdesc = &get_longdesc($result);
       $pline .=  "$longdesc";
       $pline .= $format_4;
    print $pline;
  }

	}

  if (($mag_matchcount > 0)&&($mag_matchcount>=$start)) {
	print "<table width=610 height=3 bgcolor=$COLOR>";
	print "<tr><td><b>Online Magazines</b></td></tr></table>\n";
  $i = 0;
  $start = $rqpairs{'s'};
  $end = $rqpairs{'s'}+$rqpairs{'n'}-1;
  $p_end = $end;
  if ($end > $mag_matchcount) {$p_end = $mag_matchcount;}
  print "Results $start through $p_end of $mag_matchcount for $rqpairs{'request'}.\n" unless ($mag_matchcount==0);
  foreach $pline (@s_magresults) {
    $i++;
    next if ($i < $start);
    last if ($i > $end);
    print $pline;
  }

	}
  

  print "<hr width=20>";
  if (($enc_matchcount > $end)||($mag_matchcount>$end)) {
    $new_s = $rqpairs{'s'}+$rqpairs{'n'};
     print "<center><b>";
     print "<a href=/search.fcgi?request=$x";
     print "&db=$rqpairs{'db'}&s=$new_s&n=$rqpairs{'n'}>More...</a>";
     print "</b></center>";
     }

  &print_page_bottom();
  if ($usecount>1000) { 
	warn "searchring.fcgi: I have seen 1000 requests, good-bye!";
	exit; 
	}
   }

sub print_page_top {
print "Content-type: text/html\n\n";
print "<html><head><title>Wikipedia Search Results: $rqpairs{'request'}";
print "</title></head><body bgcolor=ffffff>\n";
print &green_box($path);  # green_box is one row of the table

  print "<table border=$MB width=100\%  cellpadding=1>";
  print "<tr>";
  print "<td align=center>&nbsp;</td>\n";
  print "<td align=center>";
  print qq^
<table>
<form action="/search.fcgi" method="POST"
target=_top>
 <tr>
  <td align=center>
   <input type=text size="20"  value="$rqpairs{'request'}" name="request">
   <input type="submit" name="B1" value="Search">
  </td>
  <td>
  &nbsp;
  </td>
 </tr>
</form>
</table>^;

  print "</td>\n";
  print "<td align=center>&nbsp;</td>\n";
  print "</tr>";
  print "</table>";
  print "<center>";
}




sub green_box {
my $path = $_[0];
my $rslt;
#$rslt .= "<tr><td>&nbsp;</td><td valign=top>\n";
$rslt .= qq^
<table WIDTH="100%" BGCOLOR="#FFFFFF"> 
<tr>
    <td BGCOLOR="#FFFFFF" valign=top> 
<div align=left><font color="#000000"><font size=-1>
<a href="/wiki/HomePage">HomePage</a> | 
<a href="/wiki/Recent_Changes">Recent Changes</a> | 
<a href="/wiki.cgi?action=editprefs">Preferences</a> | 
<a href="/wiki.cgi?action=random">Random Page</a> | 
<a href=/subscribe.cgi?HomePage>Receive an article a day!</a><br>
<!--This is the experimental faster wikipedia search engine.-->
<br><big>Click to use original slow search engine: <a href=/wiki.cgi?search=$x&dosearch=1>$rqpairs{'request'}</a>. <br>
<!--<a href=/wiki/Wikipedia_commentary/Search_Engine>Click here to leave feedback</a>-->
<br>
<!--I am working on things right now, so yes, it is broken, sorry.-->

</big>
    </td> 
   <td align=right><img src="/wiki.jpg">
    </td>
</tr>

</table>
	^;

  return $rslt;
}


sub print_page_bottom {

$jumpurl = "http://www.bomis.com/cgi-bin/jump?";
$jumpurl .= "f=$x&db=$rqpairs{'db'}";


print "<p><b>Search again using these other engines:";
print "<center><table><tr><td valign=top align=center><small>";

print qq!
<a
href="$jumpurl&t=goto&j=http://service.bfast.com/bfast/click/goto?bfsiteid=340603^bfpage=search^Keywords=$x">GoTo.com</a>
 | 
<a href="$jumpurl&t=altavista&j=http://www.altavista.com/cgi-bin/query?q=$x">AltaVista</a>
 | 
<a href="$jumpurl&t=dejanews&j=http://www.dejanews.com/[LB=http://www.bomis.com/,LBT=Back%20To%20Bomis.]/dnquery.xp?query=$x&DBS=1">Deja News</a>
 | 
<a href="$jumpurl&t=yahoo&j=http://search.yahoo.com/bin/search?p=$x">Yahoo</a>
 | 
<a href="$jumpurl&t=metacrawler&j=http://www.metacrawler.com/crawler?general=$x^method=0^target=^region=0^rpp=20^timeout=5^hpe=10">MetaCrawler</a>
 | 
<a href="$jumpurl&t=google&j=http://www.google.com/search?q=$x">Google</a>
 | 
<a href="$jumpurl&t=directhit&j=http://www.directhit.com/fcgi-bin/DirectHitWeb.fcg?cmd=qry^template=search^qry=$x">Direct Hit</a>
 |
<a href="$jumpurl&t=bomis&j=http://www.bomis.com/searchring.fcgi?request=$x">Bomis</a>
</big> !;

print "<p><center>";
print &google_box();



print "</small></td><tr></table></center>";

#print "<hr><center>Another Production of <a
#href=\"http://www.bomis.com\">Bomis.Com</a>";
print "</center>";
print &green_box();
print "</body></html>\n";


}

sub handle_blank_request {
  print "<center>\n";
  print "<table border=0 width=610 cellspacing=5 cellpadding=1><tr><td>";
  print "<h1>You searched on nothing, and so we found nothing!</h1>";
#  print "<h2>Our extensive scientific research shows that when people search";
#  print " on nothing, they are bored.  The only cure for boredom is to";
#  print " surf randomly.  So now you can <a";
#  print " href=http://www.bomis.com/cgi-bin/random_ring.cgi>";
#  print "surf a random Bomis Ring</a>!!</h2>";
  print "</td></tr></table>\n";
  &print_page_bottom();
}

sub load_adult_ads {
  # Creates an array adult_ad[] with adult ads in it.
  my @adlist = `ls /home/ads/work-http/latitude90/admonitor/javascript.ad`;
  my $i;
  foreach $adfile (@adlist) {
   $i++;
   $adult_ad[$i] = &read_ad_file($adfile);
   }
return $i;  
}


sub load_slogans {
  # Creates an array slogan[] with slogans in it.
  open(SLOFILE, "slogans.txt");
  while(<SLOFILE>) {
	$i++;
	$slogan[$i] = $_;
	}
  return $i;
}




sub loadads {
  # Creates an array ad[] with ads in it.
#  my @adlist = `ls /home/ads/work-http/latitude90/admonitor/javascript.ad`;
my $i;
#  foreach $adfile (@adlist) {
#   $i++;
#   $ad[$i] = &read_ad_file($adfile);
#   }
$i = 1;
$ad[1] = &read_ad_file('/home/ads/work-http/latitude90/admonitor/javascript.ad');

return $i;
}
sub read_ad_file {
my $result;
my $adfile = $_[0];
open(INFILE, $adfile);
while(<INFILE>) {
  $result .= $_;
}
close(INFILE); 

return $result;
}

sub log_lastfew {
my $x = shift;
$x = lc($x);
return 1 if ($x =~ /porn/);
return 1 if ($x =~ /fetish/);
return 1 if ($x =~ /shemale/);
#return 1 if ($x =~ /sex/);
return 1 if ($x =~ /nude/);
return 1 if ($x =~ /babe/);
return 1 if ($x =~ /playmate/);
return 1 if ($x =~ /tit/);
return 1 if ($x =~ /hardcore/);
return 1 if ($x =~ /xxx/);
return 1 if ($x =~ /penthouse/);
return 1 if ($x =~ /blowjob/);
return 1 if ($x =~ /breast/);
return 1 if ($x =~ /anal/);
return 1 if ($x =~ /pregnant/);
return 1 if ($x =~ /cum/);
return 1 if ($x =~ /lesbian/);
return 1 if ($x =~ /pussy/);
return 1 if ($x =~ /playboy/);
return 1 if ($x =~ /slut/);
return 1 if ($x =~ /oral/);
#return 1 if ($x =~ /adult/);
return 1 if ($x =~ /fuck/);
return 1 if ($x =~ /cock/);
return 1 if ($x =~ /shit/);
my $temp = int(rand(20))+1;

$lastfew[$temp] = $x if length($rqpairs{'request'}&&($bomischecked eq 'checked')); 
return 0;
}

sub log_dbmopen_failure {
  open(DBMLOG, ">>dbmfailure.log");
  print DBMLOG "------------failure report----------\n";
  my $dbname = shift;
  print DBMLOG "Failure to open $dbname --> $!\n";
  while (($tag, $value) = each(%ENV)) {
     print DBMLOG "$tag=$value\n";
  }
  print DBMLOG "This report is from process id: $$\n";
  $now = time();
  print DBMLOG "The current time is: $now\n";
  print DBMLOG "Here's what is running right now:\n";
  print DBMLOG `ps ax`;
  print DBMLOG "Here's the uptime report:\n";
  print DBMLOG `uptime`;
  print DBMLOG "Here is rqpairs:\n";
  &ReadParse(*rqpairs);
  while (($tag, $value) = each(%rqpairs)) {
     print DBMLOG "$tag=$value\n";
  }
  
  close DBMLOG;
}

sub get_longdesc {
    my $PageName = shift;
 
    my $longdesc;  # Does this go here?
    my %longdesc;

    $line_length = 120;

   my $FirstLetter = substr($PageName, 0, 1);
    my $WikiDbFile = "$DBDIR/wiki/page/$FirstLetter/$PageName.db";
    if (-f $WikiDbFile) {
	my $dbfile;
	open(GREP_FILE, $WikiDbFile);
	while (<GREP_FILE>) {
	    $dbfile .= $_;
	}
	close(GREP_FILE);

  # read full contents of .db file into $dbfile
	%Page = split(/$FS1/, $dbfile, -1);
	%Section = split(/$FS2/, $Page{'text_default'}, -1);
	%Text = split(/$FS3/, $Section{'data'}, -1);
	$pagetext = $Text{'text'};   # text of the page

	$pagetext =~ s/\[\[//g;
	$pagetext =~ s/\]\]//g;
	$pagetext =~ s/\<.*?\>//g;
	$pagetext =~ s/\</&lt;/g;
	$pagetext =~ s/\>/&gt;/g;

	foreach $term (@searchterms) {

	    $temp = substr($pagetext, $line_length, length($pagetext));
	    if ($temp =~ /$term/gi) {
		$position = pos $temp;
	    if ($position < 40) {
		$position = 40;
	    }
 
	    $temp = "...".substr($temp, $position-40, $line_length)."...";
	    $longdesc{$temp}++; 
	       
}
	}
	$longdesc = substr($pagetext, 0, $line_length)."...<br>\n";

	while (($tag, $value) = each(%longdesc)) {
	    $longdesc .= $tag;
	    $longdesc .= "<br>\n";
	}
	foreach $term (@searchterms) {
	    $longdesc =~ s/($term)/<b>$1<\/b>/gi;
	}

	return "<i>$longdesc</i>";
#	return "Testing.";
    }
    else {
	return "No description available.";
}
}

sub google_box {
my $result = qq^
<!-- Search Google -->
<FORM method=GET action=http://www.google.com/custom>
<TABLE bgcolor=#FFFFFF cellspacing=0 border=0>
<tr valign=top>
<td>
&nbsp;
</td>
<td>
<INPUT TYPE=text name=q size=31 maxlength=255 value="$x">
<INPUT type=submit name=sa VALUE="Google Search">
<INPUT type=hidden name=cof VALUE="AH:center;AWFID:74bc54b8b218c2f9;">
<font face=arial,sans-serif size=-1>
<input type=hidden name=domains value="wikipedia.com">
<br>
<input type=radio name=sitesearch value="">
 Search WWW <input type=radio name=sitesearch value="wikipedia.com" checked>
 Search wikipedia.com</font>
 <br>
 </td>
 </tr>
 </TABLE>
 </FORM>
 <!-- Search Google -->
 ^;
return $result;
}
